/*
 Vitaly Checkryzhev, <virty1k@mail.ru>
 WWW: http://phoenix.strchat.ru
 ICQ: 55371440
 JID: vcheckryzhev@jabber.ru
*/

#include <unistd.h>
#include <time.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

// Password length
int seqlen;

#define tablen 62
const char chartable[tablen] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

#ifdef S_MD5
#include <openssl/md5.h>
#define DIGEST_LENGTH MD5_DIGEST_LENGTH
#else
#include <openssl/sha.h>
#define DIGEST_LENGTH SHA_DIGEST_LENGTH
#endif

#include "sequence.c"

unsigned char * seq;
char exit_flag = 0;		// Handle Ctrl-C

 /*   ,     , 
         */
void fsignal (int sig)
{
 switch (sig)
   {
   case SIGALRM:
    exit_flag = 0;
    break;
   case SIGTERM:
   case SIGINT:
   case SIGQUIT:
    // Some exit stuff
    if (exit_flag)
     exit (0);
    alarm (1);
    exit_flag = 1;

    printf ("C: ");
    print_seq (seq, seqlen);
    break;
   default:
    break;
   }
}

int main (int argc, char **argv)
{
 unsigned char testhash[DIGEST_LENGTH * 2],
   stxt[seqlen],
   hash[16],
   chash[16],
   found;
 time_t t;
 int i;
 long int c;

 if (argc < 3)
   {
#ifdef S_MD5
       printf ("Compiled with MD5");
#else
       printf ("Compiled with SHA1");
#endif
    printf ("\nUsage: %s password_len hash [seq_per_process]\n", argv[0]);
    return 1;
   }

 seqlen = atoi (argv[1]);
 if (seqlen < 1)
   {
    printf ("Password length must be greater than 0\n");
    return 1;
   }

 strncpy (testhash, argv[2], DIGEST_LENGTH * 2);

 for (i = 0; i < DIGEST_LENGTH; i++)
  hash[i] = hexsym (&testhash[i * 2]);

 // Init first sequence
 seq = malloc (seqlen * sizeof (char));
 for (i = 0; i < seqlen; i++)
  seq[i] = 0;

 found = 0;

 for (i = 1; i < 32; i++)	/*      fsignal */
  signal (i, fsignal);

 // Iterate all possible sequences
 t = time (NULL);
 c = 0;
 while (seq[0] < tablen)
   {
    // Get text presentation
    for (i = 0; i < seqlen; i++)
     stxt[i] = chartable[seq[i]];

#ifdef S_MD5
     MD5 (stxt, seqlen, chash);
#else
     SHA1 (stxt, seqlen, chash);
#endif

    if (strncmp (hash, chash, seqlen) == 0)
      {
       printf ("Found: ");
       print_seq (seq, seqlen);
       found = 1;
       break;
      }

    step_seq (seq, seqlen);
    c++;
   }

 if (!found)
  printf ("Shit! Sequence not found.\n");

 t = time (NULL) - t;
 printf ("Time elapsed: %d sec.\nChecked sequences: %d\nSpeed: %d c/s\n", t,
	 c, c / (t | 1));
 free (seq);
 return 0;
}
